#!/bin/bash
#
. /var/log/copfilter/default/etc/global_settings

INST=$1
if [ $INST != 0 -a $INST != 1 ]; then
	INST=0
fi

declare -i ENABLED=0
declare -i DISABLED=0
UPDATE=n

### 3rd_party - Files - Array -Start ###
declare -a FILES="Sanesecurity,spam.ldb Sanesecurity,spamimg.hdb Sanesecurity,lott.ndb Sanesecurity,spear.ndb Sanesecurity,spearl.ndb Sanesecurity,junk.ndb Sanesecurity,scam.ndb Sanesecurity,phish.ndb Sanesecurity,rogue.hdb Sanesecurity,jurlbla.ndb OITC,winnow_phish_complete.ndb,wphsh.ndb OITC,winnow_malware.hdb,wmal.hdb OITC,winnow_spam_complete.ndb,wspam.ndb OITC,winnow.complex.patterns.ldb,wpatt.ldb OITC,winnow.attachments.hdb,wattach.hdb Bill_Landry,INetMsg-SpamDomains-2w.ndb,inet.ndb Julian_Field,scamnailer.ndb SecuriteInfo,securiteinfo.hdb SecuriteInfo,honeynet.hdb SecuriteInfo,securiteinfobat.hdb,secinfobat.hdb SecuriteInfo,securiteinfodos.hdb,secinfodos.hdb SecuriteInfo,securiteinfoelf.hdb,secinfoelf.hdb SecuriteInfo,securiteinfohtml.hdb,secinfohtm.hdb SecuriteInfo,securiteinfooffice.hdb,secinfooff.hdb SecuriteInfo,securiteinfopdf.hdb,secinfopdf.hdb SecuriteInfo,securiteinfosh.hdb,secinfosh.hdb Andrew_Lewis,doppelstern.hdb,LW_Image.hdb Andrew_Lewis,doppelstern.ndb,LW_Scam.ndb MSRBL,MSRBL-Images-FULL-SoN.hdb,MSRBL_Images.hdb MSRBL,MSRBL-SPAM.ndb,MSRBL_SPAM.ndb Malware_Patrol,mbl.ndb"
### 3rd_party - Files - Array -End ###






if [ ! "x$FILES" = "x" ]; then
	cp -p $BASEDIR/etc/global_settings /tmp/
	for FILE in $FILES; do
		PRODUCER=`echo $FILE | cut -d "," -f1`
		SOURCE=`echo $FILE | cut -d "," -f2`
		TARGET=`echo $FILE | cut -d "," -f3`
		if [ "x$TARGET" = "x" ]; then
			TARGET=`echo $FILE | cut -d "," -f2`
		fi
		SIG=`echo $TARGET | cut -d "." -f1`
		APP1=_ENABLE
		APP2=_database
		COMBINED=$SIG$APP1
		echo $COMBINED > /tmp/ulow
		COMBINED=`tr '[:lower:]' '[:upper:]' < /tmp/ulow`
		rm -f /tmp/ulow>/dev/null
		SIGVALUE=`grep -E "^$COMBINED" /tmp/global_settings | cut -d "=" -f2`
		echo -e "\033[;1;31m$PRODUCER$APP2: $SOURCE\033[0m"
		echo "The current value for \"$SOURCE\" is: \"$SIGVALUE\""
		echo -n "Change value ? [y/n] "
		read CHANGE
		if [ "x$CHANGE" = "xy" ]; then
			if [ "x$SIGVALUE" = "xdisabled" ]; then
				SIG1=$COMBINED=disabled
				SIG2=$COMBINED=enabled
				cat /tmp/global_settings | sed -e "s|^$SIG1|$SIG2|" >/tmp/global_settings.tmp
				mv -fT /tmp/global_settings.tmp /tmp/global_settings
				chown nobody.nobody /tmp/global_settings
				chmod 0644 /tmp/global_settings
				SIGVALUE=`grep -E "^$COMBINED" /tmp/global_settings | cut -d "=" -f2`
				ENABLED=ENABLED+1
				echo -e "\033[;1;32mValue of \"$SOURCE\" changed to: \"$SIGVALUE\"\033[0m"
				echo""
			elif [ "x$SIGVALUE" = "xenabled" ]; then
				PRESENT=0
				SIG1=$COMBINED=enabled
				SIG2=$COMBINED=disabled
				cat /tmp/global_settings | sed -e "s|^$SIG1|$SIG2|" >/tmp/global_settings.tmp
				mv -fT /tmp/global_settings.tmp /tmp/global_settings
				chown nobody.nobody /tmp/global_settings
				chmod 0644 /tmp/global_settings
				SIGVALUE=`grep -E "^$COMBINED" /tmp/global_settings | cut -d "=" -f2`
				DISABLED=DISABLED+1
				if [ -f /tmp/clamdatabases/$TARGET ]; then
					rm -f /tmp/clamdatabases/$TARGET
				fi
				if [ -f $BASEDIR/opt/clamav/dbbackup/$TARGET ]; then
					rm -f $BASEDIR/opt/clamav/dbbackup/$TARGET
				fi
				if [ -f $BASEDIR/opt/clamav/virdb/$TARGET ]; then
					PRESENT=1
					rm -f $BASEDIR/opt/clamav/virdb/$TARGET
				fi
				echo -e "\033[;1;33mValue of \"$SOURCE\" changed to: \"$SIGVALUE\""
				if [ $PRESENT == 1 ]; then
					echo -e "Disabled file deleted.\033[0m"
				else
					echo -e "\033[0m"
					echo ""
				fi
			fi
		else
			echo -e "\033[;1;31mValue of \"$SOURCE\" remains \"$SIGVALUE\"\033[0m"
			echo ""
		fi
	done
fi

mv -fT /tmp/global_settings $BASEDIR/etc/global_settings
if [ $INST == 1 ]; then
	echo "You installed the 3rd_party_sigs on your IPCop."
	echo "Would you like to download the choosen databases immediately or will you"
	echo "wait for the download by cronjob at next 11:55 pm ?"
	echo -n "Download now ? [y/n] "
	read DOWNLOAD
	if [ "x$DOWNLOAD" != "xy" -a "x$DOWNLOAD" != "xY" ]; then
		DOWNLOAD=n
	fi
else
	if [ ! $ENABLED = 0 ]; then
		echo "You enabled $ENABLED 3rd_party_sigs on your IPCop."
		echo "Would you like to download the new choosen databases immediately"
		echo "or will you wait for the download by cronjob at next 11:55 pm ?"
		echo -n "Download now ? [y/n] "
		read DOWNLOAD
		if [ "x$DOWNLOAD" != "xy" ]; then
			DOWNLOAD=n
		fi
	fi
	if [ ! $DISABLED = 0 -a "x$DOWNLOAD" != "xy" ]; then
		echo "You disabled $DISABLED 3rd_party_sigs on your IPCop."
		echo "The disabled databases have been deleted immediately."
		echo "CLAMD will be notified of the changes and forced to reload"
		echo "the current choosen databases."
		$BASEDIR/opt/clamav/default/bin/clamdscan --reload
		ERG=$?
		if [ $ERG == 0 ]; then
			echo -e "\033[1;32mDatabases reloaded..."
			echo -e -n "clamd running with pid "`pidof clamd`
			echo -e "\033[0m"
		else
			echo -e "\033[1;31mclamd couldn't reload databases correctly, may be it's down...\033[0m"
		fi
	fi		
fi

if [ "x$DOWNLOAD" = "xy" ]; then
	echo "Your choosen databases will now be updated."
	echo -e "\033[;1;33mThis may last up to 20 minutes or more!"
	echo -e "Stay cool and have a beer.\033[;0m"
	$BASEDIR/opt/tools/bin/cron.daily >> /var/log/copfilter/default/opt/tools/var/log/crondaily.log 2>\&1
	echo -e "\033[1;31mFor more information about the download process look at"
	echo -n "your logfile /var/log/copfilter/default/opt/tools/var/log/crondaily.log..."
	echo -e "\033[0m"
fi	

echo -e "\033[;1;32;5mModification(s) done...\t\tBye.\033[0m"

exit 0