#!/bin/sh



. /var/log/copfilter/default/etc/global_settings
. /var/ipcop/main/settings
. /var/log/copfilter/default/langs/en.sh
. /var/log/copfilter/default/langs/${LANGUAGE}.sh


if [ ! -f /var/ipcop/red/active ] ; then
   echo "no internet connection available, so no updates will be downloaded" |logger -t "antivirus update avg $APPEND"
   exit
fi

if [ -f /tmp/check-updates_avg ]; then
  echo "avg update script is still running! exiting..." | logger -t "avg update script"
  exit
fi

touch /tmp/check-updates_avg

echo "removing files possibly left by the last update cycle..." |logger -t "antivirus update avg $APPEND"
rm -fv /var/log/copfilter/default/opt/avg/default/var/update/download/* |logger -t "antivirus update avg $APPEND"
rm -fv /var/log/copfilter/default/opt/avg/default/var/update/preinstall/* |logger -t "antivirus update avg $APPEND"
sleep 2


PRG="avgupdate"
PRG_PID=`pidof $PRG`
if [ $? != 0 ]; then 
     PRG_PID=""
fi

if [ "x$PRG_PID" != "x" ]; then 
          echo "avgupdate is still running! killing process..." | logger -t "antivirus update avg"
          kill -9 $PRG_PID
         sleep 1
fi

if [ -f $BASEDIR/opt/avg/default/var/run/avgupdate.pid ]; then
  echo "avgupdate.pid was not deleted when last update was finished! avgupdate will not run! deleting avgupdate.pid" | logger -t "antivirus update avg"
  rm -fv $BASEDIR/opt/avg/default/var/run/avgupdate.pid | logger -t "antivirus update avg"
  sleep 1
fi


if [ "x$1" = "xweboutput" ]; then
  APPEND="<BR>"
fi

echo "avg updating ..." | logger -t "antivirus update avg"

TMP_FILE1=$TMPDIR/avg.tmp1
TMP_FILE2=$TMPDIR/avg.tmp2
TMP_FILE3=$TMPDIR/avg.tmp3

LD_LIBRARY_PATH=$BASEDIR/opt/avg/lib $BASEDIR/opt/avg/default/bin/avgscan >$TMP_FILE1

LD_LIBRARY_PATH=$BASEDIR/opt/avg/lib $BASEDIR/opt/avg/default/bin/avgupdate --online --no-diff | logger -t "avgupdate"
#LD_LIBRARY_PATH=$BASEDIR/opt/avg/lib $BASEDIR/opt/avg/default/bin/avgupdate --online | logger -t "avgupdate"

if [ -f /*avi.av* ]; then
	echo "copying of updated files failed. doing manually..." | logger -t "manual copy due to failed avgupdate"
	mv -fv --backup=t /*avi.av* $BASEDIR/opt/avg/default/data/ | logger -t "manual copy due to failed avgupdate"
	$BASEDIR/opt/avg/etc/init.d/copfilter_avgscan reload | logger -t "manual copy due to failed avgupdate"
	ADDTXT="Virus databases manually copied to database directory due to error in \"avgupdate\" process..."
	sleep 5
fi

LD_LIBRARY_PATH=$BASEDIR/opt/avg/lib $BASEDIR/opt/avg/default/bin/avgscan >$TMP_FILE2
cp -p $TMP_FILE2 $BASEDIR/opt/avg/CURRENTVERSION
cat $BASEDIR/opt/avg/CURRENTVERSION | sed -e '/^Us/d' -e '/^Copy/d' -e '/^AVG/d' -e '/^$/d' -e '/Exp/d' > /tmp/CURRENTVERSION.AVG
echo "Lizenz l&auml;uft ab am 2011-04-07" >> /tmp/CURRENTVERSION.AVG
mv /tmp/CURRENTVERSION.AVG $BASEDIR/opt/avg/CURRENTVERSION
chmod 0644 $BASEDIR/opt/avg/CURRENTVERSION
chown root.root $BASEDIR/opt/avg/CURRENTVERSION


echo "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- AVG -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=" > $TMP_FILE3
echo >> $TMP_FILE3
echo $CP_avg_update_mail >>$TMP_FILE3
echo >> $TMP_FILE3
cat $TMP_FILE2 | sed -e '/^Us/d' -e '/^Copy/d' -e '/^AVG/d' -e '/^$/d' -e '/Exp/d' >> $TMP_FILE3
#$TMP_FILE2 |egrep -v "Usage|help" >>$TMP_FILE3
echo "License expires on 2011-04-07" >> $TMP_FILE3
echo >> $TMP_FILE3
if [ "x$ADDTXT" != "x" ]; then
	echo "$ADDTXT" >> $TMP_FILE3
	echo >> $TMP_FILE3
fi
echo >> $TMP_FILE3

diff $TMP_FILE1 $TMP_FILE2  >/dev/null 2>&1
if [ $? != 0 ]; then
  echo "update available:" | logger -t "antivirus update avg"
if [ "x${SMTP_HOST}" = "x" -o "x${EMAIL_ADR}" = "x" ] ; then
  echo "no email notification will be sent, since SMTP_HOST and/or EMAIL_ADR where not yet specified" | logger -t "antivirus update avg"
else
   cat $TMP_FILE2 | logger -t "copfilter antivirus update avg"
   if [ -f $BASEDIR/etc/smtp_auth_enable ]; then
       echo "smtp authentication enabled, using user: $SMTP_AUTH_USER" | logger -t "antivirus update avg"
       cat $TMP_FILE3 | $SENDEMAIL -xu $SMTP_AUTH_USER -xp $SMTP_AUTH_PASS \
                           -f $SENDER_ADR -t $EMAIL_ADR -s "${SMTP_HOST}"  \
                           -u "[Copfilter] AntiVirus Update: AVG" |logger -t "sendemail avg"
   else
       echo "not using smtp authentication" | logger -t "antivirus update avg"
       cat $TMP_FILE3 |  $SENDEMAIL -f $SENDER_ADR -t $EMAIL_ADR -s "${SMTP_HOST}"  \
                                    -u "[Copfilter] AntiVirus Update: AVG" |logger -t "sendemail avg"
   fi
fi
else
  echo "no update available" | logger -t "antivirus update avg"
fi
if [ -f $BASEDIR/opt/avg/default/var/run/avgupdate.pid ]; then
  echo "avgupdate.pid was not deleted when update was finished! no further updates will run!" | logger -t "antivirus update avg"
fi

rm -f $TMP_FILE1
rm -f $TMP_FILE2
rm -f $TMP_FILE3
rm -f /tmp/check-updates_avg