#!/bin/sh



. /var/log/copfilter/default/etc/global_settings
. /var/ipcop/main/settings
. /var/log/copfilter/default/langs/en.sh
. /var/log/copfilter/default/langs/${LANGUAGE}.sh


if [ ! -f /var/ipcop/red/active ] ; then
   echo "no internet connection available, so no updates will be downloaded" |logger -t "clamav freshclam $APPEND"
   exit
fi

if [ -f /tmp/check-updates_clamav ]; then
  echo "clamav updatescript is still running! exiting." | logger -t "clamav update script"
  exit
fi

touch /tmp/check-updates_clamav

if [ "x$1" = "xweboutput" ]; then
  APPEND="<BR>"
fi

echo "clamav updating ..." | logger -t "copfilter antivirus update clamav"


TMP_FILE1=$TMPDIR/clamav.tmp1
TMP_FILE2=$TMPDIR/clamav.tmp2
TMP_FILE3=$TMPDIR/clamav.tmp3
TMP_FILE4=$TMPDIR/clamav.tmp4
ls -la $BASEDIR/opt/clamav/virdb/ | sed -e '2,3D' | grep -v -i mirrors.dat >$TMP_FILE1

# sometimes freshclam hangs
# http://copfilter.endlich-mail.de/viewtopic.php?t=1161&start=15
FRESHCLAMPID=`pidof freshclam`
if [ "x${FRESHCLAMPID}" != "x" ]; then
  kill -9 `pidof freshclam`
fi


$BASEDIR/opt/clamav/default/bin/freshclam --daemon-notify --quiet -l $TMP_FILE3

ls -la $BASEDIR/opt/clamav/virdb/ | sed -e '2,3D' | grep -v -i mirrors.dat >$TMP_FILE2




echo "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= ClamAV =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=" > $TMP_FILE4
echo >> $TMP_FILE4
echo $CP_clamav_update_mail >> $TMP_FILE4
echo >> $TMP_FILE4
cat $TMP_FILE3 |sed -e '/----/d'>>$TMP_FILE4
echo >> $TMP_FILE4
echo >> $TMP_FILE4


 
diff $TMP_FILE1 $TMP_FILE2 >/dev/null 2>&1
if [ $? != 0 ]; then
  cp -a $BASEDIR/opt/clamav/virdb/main.c?d $BASEDIR/opt/clamav/dbbackup
  cp -a $BASEDIR/opt/clamav/virdb/daily.c?d $BASEDIR/opt/clamav/dbbackup
  if [ -f $BASEDIR/opt/clamav/virdb/safebrowsing.cvd -o -f $BASEDIR/opt/clamav/virdb/safebrowsing.cld ]; then
	  cp -a $BASEDIR/opt/clamav/virdb/safebrowsing.c?d $BASEDIR/opt/clamav/dbbackup
  fi
  echo "update available" | logger -t "copfilter antivirus update clamav"
if [ "x${SMTP_HOST}" = "x" -o "x${EMAIL_ADR}" = "x" ] ; then
  echo "no email notification will be sent, since SMTP_HOST and/or EMAIL_ADR where not yet specified" | logger -t "copfilter antivirus update clamav"
else
  $CLAMSCAN -V >>$TMP_FILE3 2>&1
  cat $TMP_FILE3 | logger -t "copfilter antivirus update clamav"


  grep WARNING $TMP_FILE3 >/dev/null
  if [ $? = 0 ]; then
	if [ -f $BASEDIR/etc/smtp_auth_enable ]; then
                echo "smtp authentication enabled, using user: $SMTP_AUTH_USER" | logger -t "copfilter antivirus update clamav"
		cat $TMP_FILE4 | $SENDEMAIL -xu $SMTP_AUTH_USER -xp $SMTP_AUTH_PASS \
                            	-f $SENDER_ADR -t $EMAIL_ADR -s "${SMTP_HOST}"  \
                		-u "[Copfilter] AntiVirus Update: ClamAV - WARNING" |logger -t "sendemail clamav"
#                		-u "[Copfilter] AntiVirus Update: ClamAV" |logger -t "sendemail clamav"
	else
            echo "not using smtp authentication" | logger -t "copfilter antivirus update clamav"
    		cat $TMP_FILE4 |  $SENDEMAIL -f $SENDER_ADR -t $EMAIL_ADR -s "${SMTP_HOST}"  \
                               -u "[Copfilter] AntiVirus Update: ClamAV - WARNING" |logger -t "sendemail clamav" 
#                             -u "[Copfilter] AntiVirus Update: ClamAV" |logger -t "sendemail clamav" 
	fi
  else 
        if [ -f $BASEDIR/etc/smtp_auth_enable ]; then
                echo "smtp authentication enabled, using user: $SMTP_AUTH_USER" | logger -t "copfilter antivirus update clamav"
                cat $TMP_FILE4 | $SENDEMAIL -xu $SMTP_AUTH_USER -xp $SMTP_AUTH_PASS \
                                -f $SENDER_ADR -t $EMAIL_ADR -s "${SMTP_HOST}"  \
                                -u "[Copfilter] AntiVirus Update: ClamAV" |logger -t "sendemail clamav"
        else
            echo "not using smtp authentication" | logger -t "copfilter antivirus update clamav"
    		cat $TMP_FILE4 |  $SENDEMAIL -f $SENDER_ADR -t $EMAIL_ADR -s "${SMTP_HOST}"  \
                                -u "[Copfilter] AntiVirus Update: ClamAV" |logger -t "sendemail clamav"

        fi
  fi
fi
else
  echo "no update available" | logger -t "copfilter antivirus update clamav"
fi


cat $TMP_FILE3 >>/var/log/copfilter/default/opt/clamav/var/log/freshclam.log

#cleanup
rm -f $TMP_FILE1
rm -f $TMP_FILE2
  grep updated $TMP_FILE3 >/dev/null
  if [ $? = 0 ]; then
	cat $TMP_FILE3 | grep -E "^main\.c.*\(version:.*$" | sed -e '1!d' >  /tmp/fresh.log.tmp
	MAIN=`cat  /tmp/fresh.log.tmp | grep -E "^main" | cut -d "," -f1`
	cat $TMP_FILE3 | grep -E "^daily\.c.*\(version:.*$" | sed -e '1!d' >  /tmp/fresh.log.tmp
	DAILY=`cat /tmp/fresh.log.tmp | grep -E "^daily" | cut -d "," -f1`
	  if [ -f $BASEDIR/opt/clamav/virdb/bytecode.cvd -o -f $BASEDIR/opt/clamav/virdb/bytecode.cld ]; then
		cat $TMP_FILE3 | grep -E "^bytecode\.c.*\(version:.*$" | sed -e '1!d' >  /tmp/fresh.log.tmp
		BCODE=`cat /tmp/fresh.log.tmp | grep -E "^bytecode" | cut -d "," -f1`
	fi
	  if [ -f $BASEDIR/opt/clamav/virdb/safebrowsing.cvd -o -f $BASEDIR/opt/clamav/virdb/safebrowsing.cld ]; then
		cat $TMP_FILE3 | grep -E "^safebrowsing\.c.*\(version:.*$" | sed -e '1!d' >  /tmp/fresh.log.tmp
		SAFEBROWSE=`cat /tmp/fresh.log.tmp | grep -E "^safebrowsing" | cut -d "," -f1`
	fi
#	MAIN="$MAIN,"
#	DAILY="$DAILY,"
#	SAFEBROWSE="$SAFEBROWSE,"
	echo $MAIN > /tmp/fresh.log.tmp
	echo $DAILY >> /tmp/fresh.log.tmp
	  if [ -f $BASEDIR/opt/clamav/virdb/bytecode.cvd -o -f $BASEDIR/opt/clamav/virdb/bytecode.cld ]; then
		echo $BCODE >> /tmp/fresh.log.tmp
	  fi
	  if [ -f $BASEDIR/opt/clamav/virdb/safebrowsing.cvd -o -f $BASEDIR/opt/clamav/virdb/safebrowsing.cld ]; then
		echo $SAFEBROWSE >> /tmp/fresh.log.tmp
	  fi
	mv -f /tmp/fresh.log.tmp /var/log/copfilter/default/opt/clamav/var/log/CURRENTVERSION
	chmod 0755 /var/log/copfilter/default/opt/clamav/var/log/CURRENTVERSION
	chown root:root /var/log/copfilter/default/opt/clamav/var/log/CURRENTVERSION
	rm -f $TMP_FILE3
  else
	rm -f $TMP_FILE3
  fi
rm -f $TMP_FILE4
rm -f /tmp/check-updates_clamav

