#!/bin/sh



. /var/log/copfilter/default/etc/global_settings
. /var/ipcop/main/settings
. /var/log/copfilter/default/langs/en.sh
. /var/log/copfilter/default/langs/${LANGUAGE}.sh


if [ ! -f /var/ipcop/red/active ] ; then
   echo "no internet connection available, so no updates will be downloaded" |logger -t "antivirus update fprot $APPEND"
   exit
fi

if [ -f /tmp/check-updates_fprot ]; then
  echo "fprot update script is still running! exiting..." | logger -t "fprot update script"
  exit
fi

touch /tmp/check-updates_fprot

if [ "x$1" = "xweboutput" ]; then
  APPEND="<BR>"
fi

echo "f-prot updating ..." | logger -t "antivirus update fprot"

#PATH=$BASEDIR/opt/f-prot_tools/default/bin/:$PATH
TMP_FILE1=$TMPDIR/f-prot.tmp1
TMP_FILE2=$TMPDIR/f-prot.tmp2
TMP_FILE3=$TMPDIR/f-prot.tmp3

$FPROT --version >$TMP_FILE1

$BASEDIR/opt/f-prot/default/fpupdate |logger -t "f-prot fpupdate"

$FPROT --version >$TMP_FILE2
$FPROT --version >$BASEDIR/opt/f-prot/CURRENTVERSION
cat $BASEDIR/opt/f-prot/CURRENTVERSION | sed -e '/^Argum/d' -e '/^$/d' -e'/^ /d' -e '/FRISK/d' > /tmp/CURRENTVERSION.FP
echo "Lizenz l&auml;uft ab am 2010-04-19" >> /tmp/CURRENTVERSION.FP
mv /tmp/CURRENTVERSION.FP $BASEDIR/opt/f-prot/CURRENTVERSION
chmod 0644 $BASEDIR/opt/f-prot/CURRENTVERSION
chown root.root $BASEDIR/opt/f-prot/CURRENTVERSION

echo "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= F-Prot =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=" > $TMP_FILE3
echo >> $TMP_FILE3
echo $CP_fprot_update_mail >>$TMP_FILE3
echo >> $TMP_FILE3
cat $TMP_FILE2 | sed -e '/^Argum/d' -e '/^$/d' -e'/^ /d' -e '/FRISK/d' >> $TMP_FILE3
#cat $TMP_FILE2 >>$TMP_FILE3
echo "Lizenz luft ab am 2010-04-19" >> $TMP_FILE3
echo >> $TMP_FILE3
echo >> $TMP_FILE3

diff $TMP_FILE1 $TMP_FILE2  >/dev/null 2>&1
if [ $? != 0 ]; then
  echo "update available:" | logger -t "antivirus update fprot"
if [ "x${SMTP_HOST}" = "x" -o "x${EMAIL_ADR}" = "x" ] ; then
  echo "no email notification will be sent, since SMTP_HOST and/or EMAIL_ADR where not yet specified" | logger -t "antivirus update fprot"
else
  cat $TMP_FILE2 | logger -t "copfilter antivirus update fprot"
  if [ -f $BASEDIR/etc/smtp_auth_enable ]; then
      echo "smtp authentication enabled, using user: $SMTP_AUTH_USER" | logger -t "antivirus update fprot"
      cat $TMP_FILE3 | $SENDEMAIL -xu $SMTP_AUTH_USER -xp $SMTP_AUTH_PASS \
                          -f $SENDER_ADR -t $EMAIL_ADR -s "${SMTP_HOST}"  \
                          -u "[Copfilter] AntiVirus Update: F-PROT" |logger -t "sendemail fprot"
  else
      echo "not using smtp authentication" | logger -t "antivirus update fprot"
      cat $TMP_FILE3 | $SENDEMAIL -f $SENDER_ADR -t $EMAIL_ADR -s "${SMTP_HOST}"  \
                                  -u "[Copfilter] AntiVirus Update: F-PROT" |logger -t "sendemail fprot"
 
  fi
fi
else
  echo "no update available" | logger -t "antivirus update fprot"
fi

rm -f $TMP_FILE1
rm -f $TMP_FILE2
rm -f $TMP_FILE3
rm -f /tmp/check-updates_fprot